import java.io.*;

public class Degree {
    
    public static void main(String []args) {
        
        if ( args.length != 1 ) {
           System.out.println("Give the number of tests as argument");
           System.out.println("It is 105 for y.bat and 161 for x.bat");
        }
        int realNumTests = 0;
        try {
           realNumTests = Integer.parseInt(args[0]);
        } catch ( Exception e ) {
            System.out.println("Give the number of tests as argument");
            return;
        }
        
        File f = new File(".");

        FileOutputStream  outputStream;
        try { 
           outputStream = new FileOutputStream("out.txt");
        } catch ( FileNotFoundException e ) {
           System.out.println("Error creating file out.txt");
           return ;
        }
        PrintWriter out = new PrintWriter(outputStream);
        int numTests = 0;
        int numErrors = 0;
        int n = 0;
        String []files = f.list();
        for (int i = 0; i < files.length; i++) {
           String fileName = files[i];
           fileName = fileName.toLowerCase();
           if ( fileName.endsWith(".txt") ) {
              n++;
              String realFileName = fileName.substring(0, fileName.indexOf('.')) + ".s";
              if ( fileName.startsWith("er-") ) {
                 numTests++;
                 if ( ! read(fileName) ) 
                    System.out.println("Error in reading " + fileName);
                 else
                    if ( input[0] != '0' ) {
                       out.println("Error in file " + realFileName + " was not signalled");
                       numErrors++;
                    }
              }
              else if ( fileName.startsWith("ok-") ) {
                 numTests++;
                 if ( ! read(fileName) ) 
                    System.out.println("Error in reading " + fileName);
                 else
                    if ( input[0] != '1' ) {
                       out.println("It was signalled a non-existing error in file " + realFileName);
                       numErrors++;
                    }
              }
           }
        }
        /*
        System.out.println("realNumTests = " + realNumTests);
        System.out.println("numTests = " + numTests);
        System.out.println("numErrors = " + numErrors); 
        System.out.println("num .txt = " + n);
        */
        int numRealErrors = realNumTests - numTests + numErrors;
        //System.out.println("numRealErrors = " + numRealErrors);
        out.println("There " + (numRealErrors == 1 ? "is " : "are ") + numRealErrors + " errors in your compiler");
        out.close();
        System.out.println("The output was put at file out.txt");   
    }
    
    public static boolean read(String fileName) {
       FileReader stream;

       File file = new File(fileName);
       if ( ! file.exists() || ! file.canRead() ) {
          System.out.println("Either the file " + fileName + " does not exist or it cannot be read");
          return false;
       }
       try { 
          stream = new FileReader(file);  
       } catch ( FileNotFoundException e ) {
          System.out.println("Something wrong: file " + fileName + " does not exist anymore");
          throw new RuntimeException();
       }
                // one more character for '\0' at the end that will be added by the
                // compiler
       input = new char[ (int ) file.length() + 1 ];
       int numChRead;
            
       try {
          numChRead = stream.read( input, 0, (int ) file.length() );
       } catch ( IOException e ) {
          System.out.println("Error reading file " + fileName );
          return false;
       }
                
       if ( numChRead != file.length() ) {
          System.out.println("Read error in " + fileName);
          return false;
       }
       try {
          stream.close();
       } catch ( IOException e ) {
          System.out.println("Error in handling the file " + fileName);
          return false;
       }
       return true;
    }
                
   static private char []input;   
}